(** @author: Benoît Montagu <benoit.montagu@inria.fr>
    Copyright © Inria 2020
*)

module Analyze
    (Log: Logs.S)
    (Options: sig
       val refine_branches: bool
       val branch_is_context: bool
       val let_is_context: bool
       val no_env_restrict: bool
       val kill_unreachable: bool
       val debug: bool
     end)
    (Calls: Calls.S)
    (Bools: AbstractDomains.Sigs.BOOL_DOMAIN)
    (Ints: AbstractDomains.Sigs.INT_DOMAIN):
sig
  module Abs: sig
    type t
    val pp: Format.formatter -> t -> unit
  end

  val eval: Lang.Ast.Term.t -> (Abs.t * Memo.Statistics.t)
end
